%define upstream_name    Search-Binary
%define upstream_version 0.99

%{?perl_default_filter}

Name:       perl-%{upstream_name}
Version:    %perl_convert_version %{upstream_version}
Release:    %mkrel 4

Summary:    Generic binary search
License:    GPL+ or Artistic
Group:      Development/Perl
Url:        http://search.cpan.org/dist/%{upstream_name}
Source0:    http://www.cpan.org/modules/by-module/Search/%{upstream_name}-%{upstream_version}.tar.gz

BuildRequires: perl(Carp)
BuildRequires: perl(Exporter)
BuildRequires: perl(ExtUtils::MakeMaker)
BuildRequires: perl(Test::More) >= 0.960.0
BuildRequires: perl(Test::Warnings) >= 0.12.0
BuildRequires: perl(lib)
BuildRequires: perl(parent)
BuildRequires: perl(strict)
BuildRequires: perl(warnings)
BuildArch:  noarch

%description
'binary_search' implements a generic binary search algorithm returning the
_position_ of the first _record_ whose _index value_ is greater than or
equal to '$val'. The search routine does not define any of the terms
_position_, _record_ or _index value_, but leaves their interpretation and
implementation to the user supplied function '&$read()'. The only
restriction is that positions must be integer scalars.

During the search the read function will be called with three arguments:
the input parameters '$handle' and '$val', and a position. If the position
is not 'undef', the read function should read the first whole record
starting at or after the position; otherwise, the read function should read
the record immediately following the last record it read. The search
algorithm will guarantee that the first call to the read function will not
be with a position of 'undef'. The read function needs to return a two
element array consisting of the result of comparing '$val' with the index
value of the read record and the position of the read record. The
comparison value must be positive if '$val' is strictly greater than the
index value of the read record, '0' if equal, and negative if strictly
less. Furthermore, the returned position value must be greater than or
equal to the position the read function was called with.

The input parameters '$min' and '$max' are positions and represents the
extent of the search. Only records which begin at positions within this
range (inclusive) will be searched. Moreover, '$min' must be the starting
position of a record. If present '$size' is a difference between positions
and determines when the algorithms switches to a sequential search. '$val'
is an index value. The value of '$handle' is of no consequence to the
binary search algorithm; it is merely passed as a convenience to the read
function.

%prep
%setup -q -n %{upstream_name}-%{upstream_version}

%build
%{__perl} Makefile.PL INSTALLDIRS=vendor

%make


%install
%makeinstall_std

%files
%doc Changes LICENSE META.json META.yml MYMETA.yml README
%{_mandir}/man3/*
%perl_vendorlib/*

%changelog
* Wed Jul 12 2017 bb2 <bb2> - 0.990.0-4pclos2017
- rebuild against updates

